/*
** 64 memory handling (header file)
*/
#ifndef MEMHAND_H
#define MEMHAND_H

    #include "define.h"

    extern char boot[0x2000];  // Boot code
    extern char *g_n64rom;
    extern unsigned int size;  // Keep how big the rom is in memory.

    extern inline BYTE getbyte(unsigned int);
    extern WORD getword(unsigned int);
    extern DWORD getdword(unsigned int);
    extern QWORD getqword(unsigned int);

    extern inline void putbyte(unsigned int, BYTE);
    extern inline void putword(unsigned int, WORD);
    extern inline void putdword(unsigned int, DWORD);
    extern inline void putqword(unsigned int, QWORD);

    extern char RDram_Registers[0x2F];     // 3f00000h - 3f0002Fh
    extern char *RDram;                    // bleah
    extern char *SP_Registers;             // 0400000h     // Boot?
    extern char DP_Cmd_Registers[0x0F];    // 0410000h
    extern char DP_Span_Registers[0x0F];   // 0420000h
    extern char MI_Registers[0x0F];        // 0430000h
    extern char VI_Registers[0x37];        // 0440000h
    extern char AI_Registers[0x17];        // 0450000h
    extern char PI_Registers[0x34];        // 0460000h
    extern char RI_Registers[0x1F];        // 0470000h
    extern char SI_Registers[0x1B];        // 0480000h
    extern char PIF_RxM[0x7FF];            // 0FC0000H - 0FC007FF

    typedef struct PI_typ_
    {
      DWORD DRAM;
      DWORD Cart;
      DWORD RD_LEN;
      DWORD WR_LEN;
    }PI_typ;

    extern PI_typ PI;

#endif
