#include "utils.h"

// this function will swap the bytes in a short int(16-bit)
void SwapBytes(WORD *var)
{
    WORD temp;
    temp = (*var >> 8);
    temp |= (*var << 8);
    *var = temp;
}

void SwapWords(DWORD *var)
{
    DWORD temp;
    temp = (*var >> 16);
    temp |= (*var << 16);
    *var = temp;
}

void PrintInfos()
{
    printf("Some code by Chris Le Blond (Baalzamon)\n");
    printf("The code is based on Nincest64 by Marius Dumitrean [marius@faraway.ml.org]\n\n");
}

int mmuHack()
{
    #ifdef GP2X
    // charge le hack mmu
    int mmufd;
    system("/sbin/rmmod mmuhack");
    system("/sbin/insmod mmuhack.o");
    mmufd = open("/dev/mmuhack", O_RDWR);
    if(mmufd < 0)
        return -1;

    close(mmufd);
    #endif
    return 0;
}

void closeMmuHack()
{
    #ifdef GP2X
    system("/sbin/rmmod mmuhack");
    #endif
}

void setCpuClock(unsigned int mhz)
{
    #ifdef GP2X
    if(mhz <= 266 && mhz >= 50)
    {
        // variables
        unsigned long gp2x_mem;
        unsigned short *gp2x_memregs;
        volatile unsigned short *MEM_REG;

        // open MEM_REG
        gp2x_mem = open("/dev/mem", O_RDWR);
        gp2x_memregs=(unsigned short *)mmap(0, 0x10000, PROT_READ|PROT_WRITE, MAP_SHARED, gp2x_mem, 0xc0000000);
        MEM_REG=&gp2x_memregs[0];

        //mhz = constrain(mhz,50,maxClock);
        unsigned v;
        unsigned mdiv,pdiv=3,scale=0;

        mhz*=1000000;
        mdiv=(mhz*pdiv)/SYS_CLK_FREQ;
        mdiv=((mdiv-8)<<8) & 0xff00;
        pdiv=((pdiv-2)<<2) & 0xfc;

        scale&=3;
        v=mdiv | pdiv | scale;
        MEM_REG[0x910>>1]=v;
    }
    #else
        mhz = 0;
    #endif
}

void ramHack()
{
    #ifdef GP2X
    unsigned long gp2x_mem;
    unsigned short *gp2x_memregs;
    volatile unsigned short *MEM_REG;

    // open MEM_REG
    gp2x_mem = open("/dev/mem", O_RDWR);
    gp2x_memregs=(unsigned short *)mmap(0, 0x10000, PROT_READ|PROT_WRITE, MAP_SHARED, gp2x_mem, 0xc0000000);
    MEM_REG=&gp2x_memregs[0];

    unsigned long interrupt_flags = MEM_REG[0x808>>2],

    CAS=0,tRC=6-1,tRAS=4-1,tWR=1-1,tMRD=1-1,tRFC=1-1,tRP=2-1,tRCD=2-1; //craigix's timings

      MEM_REG[0x0808>>2] = 0xFF8FFFE7;        // Mask interrupts

      //gp2x_memregs[0x0910>>1] = s;                 // Set clock and wait

      //while(gp2x_memregs[0x0902>>1] & 1);

      gp2x_memregs[0x3802>>1] = ((tMRD<<12)|(tRFC<<8)|(tRP<<4)|(tRCD)); //set RAM tweaks
      gp2x_memregs[0x3804>>1] = ((CAS<<12)|(tRC<<8)|(tRAS<<4)|(tWR));

      gp2x_memregs[0x0924>>1] = 0x8900 + ((1)<<8); // Set upll timing prescaler to 1 (0x5A00 for fw 1.0.x)

      MEM_REG[0x0808>>2] = interrupt_flags;   // Turn on interrupts

    close(gp2x_mem);
    #endif
}
